/*
 *--------------------------------------------------------------------
 *
 * Font
 *
 * Funkce pro praci s fonty a texty jimi vykreslovane
 *
 * verze   0.0.2 - 10.06.1999
 * autori  Rory
 *
 *--------------------------------------------------------------------
 */

#ifndef FONT_H_42
#define FONT_H_42

#include "types.h"

struct Font {
   Surface data;
   DWORD xsize;
   DWORD ysize;
   BYTE xand;
   BYTE yshift;
   BYTE rsize;
   BYTE first;
};

extern Font qfont_r;
extern Font qfont_g;
extern Font qfont_b;
extern Font qfont_y;
extern Font qfont_w;
extern Font sfont_w;
extern Font scorefont_b;
extern Font scorefont_g;

void loadFonts();
void putString(DWORD x,DWORD y,Surface dest,const char *text,Font &fontbool, 
               bool checkbounds = true);
void putStringCentered(DWORD x,DWORD y,Surface dest,const char *text,Font &font);
Surface getPutString(const char *text, Font &font, RECT *surfr = NULL);

#endif