//*************************************************************************
//                                Password                                
//*************************************************************************
// Written by : Gunny
// Language   : BC++ 3.1
// Version    : 1.05
// Last update: 17.08.98
//*************************************************************************
/*
na zakodovani a odkodovani poctu zivotu a jmena souboru do nejakeho levelu
*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "pass.h"

#define PTEST

char ord(char c)
 {
  if (c>='0' && c<='9')
    return c-'0';
  else
    return c+10-'A';
 }

unsigned char chr(char n)
 {
  n=(n+36) % 36;
  if (n>9) n+=7;
  return ('0'+n);
 }

void encode(char *pass, const char *name, unsigned char *num)
 {
  int r=10+random(26);
  char c=chr(r);
  *pass=c;
  pass++;
  //to by byl zacatek
  c=chr(ord(c)+ord('A'+*num));
  *pass=c;
  pass++;
  //mam cislo, jdu na text
  while (*name)
   {
    c=chr(ord(c)+ord(toupper(*name)));
    *pass=c;
    pass++;
    name++;
   }
  //crc
  c=chr(ord(c)+r);
  *pass=c;
  pass++;
  //na konec prijde 0
  *pass=0;
 }

void decode(const char *pass, char *name, unsigned char *num)
 {
  if (strlen(pass)<3)
   {
    *name=0;
    return;
   }
  char c=*pass;
  char r=c;
  pass++;
  //cislo
  *num = chr(ord(*pass)-ord(c)) - 'A';
  c=*pass;
  pass++;
  //text
  while (*pass)
   {
    *name=chr(ord(*pass)-ord(c));
    c=*pass;
    pass++;
    name++;
   }
  //'crc'
  name--;
  #ifndef PTEST
  printf("%i\n",r);
  printf("%i\n",*name);
  #endif
  if (*name!=r)
   {
    //printf("BAD\n");
    *num=1;
   }
  //na konec prijde 0
  *name=0;
 }

#ifndef PTEST
void main()
 {
  char l[32]="well";
  char p[32];
  unsigned char n=5;
  randomize();
//  for (char i='0'; i<='Z'; i++) printf(" %i ",ord(i));
//  for (char i=0; i<36; i++) printf(" %c ",chr(i));

//do{
  printf("\npuvodni:\t%i-'%s'\n",n,l);
  encode(p,l,&n);
  printf("kod:\t\t%s\n",p);
  strcpy(l,"XXXXXX");
  gets(p);
  printf("kod:\t\t%s\n",p);
  decode(p,l,&n);
  printf("nove:\t\t%i-'%s'\n",n,l);
//  } while (n!=1);
 }
#endif