#ifndef FADER_H_BUBWINY
#define FADER_H_BUBWINY

#include "gamestage.h"

#define FADE_IN    1
#define FADE_OUT  -1
#define FADE_NONE  0

class Fader : public GameStage {
   int dir;
   int step;
   bool done;
   DWORD oldtime;
public:
   Fader()
   {
      dir = FADE_IN;
   }

   virtual void load();
   virtual void start();
   virtual void update();
   virtual void stop();
   virtual void unload();
   virtual void restore();

   void setFadeDir(int fadedir);
};

#endif
