/*****************************************************************************
...works with .ini
******************************************************************************
Written by : Gunny
Version    : 0.92
Last update: 04.05.99
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "readini.h"

//#define READINITEST

int BreakLine(char * source, char * var, char * val)
// pozor! muze modifikovat source!
// navratove hodnoty:
// 0 	var
// 1 	[ val ] (val = "ID")
// 2 	var = val
{
   int res = 0;
   int whitespace = 1;
   char * tmp;
   char * tmpto;
   //
   // neni neco zaremovane?
   tmp = strchr(source,';');
   if (tmp != NULL)
   {
      *tmp = 0;
   }
   // je to tag sekce nebo promenna?
   if (strchr(source,']') != NULL)
   {
      // znacka sekce
      sscanf(source," [ %s ] ",val);
      tmp = strchr(val,']');
      if (tmp != NULL)
      {
         *tmp = 0;
      }
      strcpy(var,"ID");
      res = 1;
   }
   else
   {
      // normalni promenna - let's go!
      *val = 0;
      tmp = source;
      tmpto = var;
      while (*tmp != 0)
      {
         if (*tmp == '=')
         {
            res = 2;
            *tmpto = 0;
            tmpto = val;
            whitespace = 1;
            tmp++;
         }
         if (*tmp > ' ' || !whitespace)
         {
            whitespace = 0;
            *tmpto = *tmp;
            tmpto++;
         }
         tmp++;
      }
      *tmpto = 0;
      // ted jeste orezat prebytecne mezery na konci
      // var
      tmp = strchr(var,0);
      tmp--;
      while (tmp>var && *tmp<=' ')
      {
         *tmp = 0;
         tmp--;
      }
      // val
      tmp = strchr(val,0);
      tmp--;
      while (tmp>val && *tmp<=' ')
      {
         *tmp = 0;
         tmp--;
      }
   }
   return res;
}

void NumVal(char * s, long * numx, long * numy)
// neumi znamenka! znaky mimo 0-9 ignoruje
{
   // X
   *numx = -1; // kdyby to delalo bordel, tak sem dame treba -1
   while (*s != 0 && *s != ',')
   {
      if (*numx < 0)
         *numx = 0;
      if (*s>='0' && *s<='9') *numx = (*numx)*10 + (*s - '0');
      s++;
   }
   if (*s==',') s++;
   // Y
   *numy = -1;
   while (*s != 0 && *s != ',')
   {
      if (*numy < 0)
         *numy = 0;
      if (*s>='0' && *s<='9') *numy = (*numy)*10 + (*s - '0');
      s++;
   }
}

#ifdef READINITEST
void main()
{
   int tag;
   char var[40];
   char val[40];
   //  tag = BreakLine(" d dff \t  =neco   76  ",var,val);
   tag = BreakLine(" [  31] = 1 ",var,val);
   printf("\n%i|\n%s|\n%s|\n",tag,var,val);
}


#endif