#ifndef MENU_H_BUBWINY
#define MENU_H_BUBWINY

#include "types.h"
#include "gamestage.h"
#include "menuobject.h"

typedef union {
   DWORD mulvalue;
   WORD value[2];
} MoveValue;

class Menu : public GameStage {
public:
   MenuObject *menu;
   MenuObject mainmenu;
   MenuObject optionmenu;
   MenuObject creditmenu;
   MenuObject helpmenu;
   MenuObject help2menu;
   MenuObject keymenu;
   MenuObject soundmenu;
   MenuObject toppermenu;

   int movex,movey;
   DWORD destx,desty;
   DWORD oldtime;
   int maxspeedx,maxspeedy;
   MoveValue x, y;
   Surface menugfx;
   char exitsys;
   char exitmenu;

   Menu();

   virtual void load();
   virtual void start();
   virtual void update();
   virtual void stop();
   virtual void unload();
   virtual void restore();     

   void startToppers();
   void stopToppers();
};

#endif